MODULE GETDATA_SHALLOW_MOD

USE ARRAYS_MANIP, ONLY: SETUP, REPLICATE, NPROMIZE, INTERPOLATE, SET

CONTAINS

SUBROUTINE GETDATA_SHALLOW (NPROMA, NGPBLKS, NFLEVG, KRR, KRRL, KRRI, KSV, KLEV, &
                        !IN and INOUT (allocation and reading)
                        &PDZZF_B, PZZ_B, PRHODJ_B, PRHODREF_B, PPABSM_B, PEXNM_B, &
                        &PSFTH_B, PSFRV_B, &
                        &PTHM_B, PRM_B, &
                        &PUM_B, PVM_B, PTKEM_B, PSVM_B, PTHL_UP_B, &
                        &PRT_UP_B, PRV_UP_B, PRC_UP_B, &
                        &PRI_UP_B, &
                        &PU_UP_B, &
                        &PV_UP_B, PTHV_UP_B, PW_UP_B, PFRAC_UP_B, PEMF_B, &
                        !OUT (allocation)
                        &PDUDT_MF_B, &
                        &PDVDT_MF_B,PDTHLDT_MF_B,PDRTDT_MF_B,PDSVDT_MF_B,PSIGMF_B,PRC_MF_B,PRI_MF_B,PCF_MF_B, &
                        &PFLXZTHVMF_B,ZFLXZTHMF_B, &
                        &ZFLXZRMF_B,ZFLXZUMF_B, &
                        &ZFLXZVMF_B,ZDETR_B,ZENTR_B, IKLCL_B, IKETL_B, IKCTL_B,&
                        !OUT and INOUT (expected values)
                        &PDUDT_MF_OUT_B, PDVDT_MF_OUT_B, &
                        &PDTHLDT_MF_OUT_B, PDRTDT_MF_OUT_B, &
                        &PDSVDT_MF_OUT_B, PSIGMF_OUT_B, PRC_MF_OUT_B, PRI_MF_OUT_B, PCF_MF_OUT_B, PFLXZTHVMF_OUT_B, ZFLXZTHMF_OUT_B, &
                        &ZFLXZRMF_OUT_B, &
                        &ZFLXZUMF_OUT_B, ZFLXZVMF_OUT_B, PTHL_UP_OUT_B, PRT_UP_OUT_B, PRV_UP_OUT_B, PRC_UP_OUT_B, PRI_UP_OUT_B, &
                        &PU_UP_OUT_B, PV_UP_OUT_B, &
                        &PTHV_UP_OUT_B, PW_UP_OUT_B, &
                        &PFRAC_UP_OUT_B, PEMF_OUT_B, ZDETR_OUT_B, ZENTR_OUT_B, IKLCL_OUT_B, IKETL_OUT_B, IKCTL_OUT_B)

IMPLICIT NONE

INTEGER, PARAMETER :: IFILE = 77

INTEGER      :: KLON 
INTEGER      :: KIDIA  
INTEGER      :: KFDIA  
INTEGER      :: KLEV  
INTEGER      :: KRR, KRRL, KRRI
INTEGER      :: KSV
INTEGER      :: KDUM

LOGICAL :: LDVERBOSE

!IN and INOUTS
REAL, ALLOCATABLE   :: PDZZF_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PZZ_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PRHODJ_B            (:,:,:,:)
REAL, ALLOCATABLE   :: PRHODREF_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PPABSM_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PEXNM_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PSFTH_B        (:,:,:)
REAL, ALLOCATABLE   :: PSFRV_B        (:,:,:)
REAL, ALLOCATABLE   :: PTHM_B           (:,:,:,:)
REAL, ALLOCATABLE   :: PRM_B            (:,:,:,:,:) !(KLON, 1, KLEV, KRR)
REAL, ALLOCATABLE   :: PUM_B              (:,:,:,:)
REAL, ALLOCATABLE   :: PVM_B              (:,:,:,:)
REAL, ALLOCATABLE   :: PTKEM_B            (:,:,:,:)
REAL, ALLOCATABLE   :: PSVM_B             (:,:,:,:,:) !(KLON,1,KLEV,KSV)
REAL, ALLOCATABLE   :: PTHL_UP_B            (:,:,:,:)
REAL, ALLOCATABLE   :: PRT_UP_B         (:,:,:,:)
REAL, ALLOCATABLE   :: PRV_UP_B         (:,:,:,:)
REAL, ALLOCATABLE   :: PRC_UP_B          (:,:,:,:)
REAL, ALLOCATABLE   :: PRI_UP_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PU_UP_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PV_UP_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PTHV_UP_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PW_UP_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PFRAC_UP_B            (:,:,:,:)
REAL, ALLOCATABLE   :: PEMF_B       (:,:,:,:)

!OUT
REAL, ALLOCATABLE   :: PDUDT_MF_B            (:,:,:,:)
REAL, ALLOCATABLE   :: PDVDT_MF_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PDTHLDT_MF_B             (:,:,:,:)
REAL, ALLOCATABLE   :: PDRTDT_MF_B           (:,:,:,:)
REAL, ALLOCATABLE   :: PDSVDT_MF_B             (:,:,:,:,:) !(KLON,1,KLEV,KSV)
REAL, ALLOCATABLE   :: PSIGMF_B              (:,:,:,:)
REAL, ALLOCATABLE   :: PRC_MF_B              (:,:,:,:)
REAL, ALLOCATABLE   :: PRI_MF_B           (:,:,:,:)
REAL, ALLOCATABLE   :: PCF_MF_B           (:,:,:,:)
REAL, ALLOCATABLE   :: PFLXZTHVMF_B             (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZTHMF_B            (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZRMF_B       (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZUMF_B       (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZVMF_B     (:,:,:,:)
REAL, ALLOCATABLE   :: ZDETR_B      (:,:,:,:)
REAL, ALLOCATABLE   :: ZENTR_B      (:,:,:,:)
INTEGER, ALLOCATABLE:: IKLCL_B  (:,:,:)
INTEGER, ALLOCATABLE:: IKETL_B  (:,:,:)
INTEGER, ALLOCATABLE:: IKCTL_B (:,:,:)


!Expected values
REAL, ALLOCATABLE   :: PDUDT_MF_OUT_B    (:,:,:,:)
REAL, ALLOCATABLE   :: PDVDT_MF_OUT_B   (:,:,:,:)
REAL, ALLOCATABLE   :: PDTHLDT_MF_OUT_B         (:,:,:,:)
REAL, ALLOCATABLE   :: PDRTDT_MF_OUT_B          (:,:,:,:)
REAL, ALLOCATABLE   :: PDSVDT_MF_OUT_B         (:,:,:,:,:) !(KLON,1,KLEV,KSV)
REAL, ALLOCATABLE   :: PSIGMF_OUT_B         (:,:,:,:)
REAL, ALLOCATABLE   :: PRC_MF_OUT_B         (:,:,:,:)
REAL, ALLOCATABLE   :: PRI_MF_OUT_B        (:,:,:,:)
REAL, ALLOCATABLE   :: PCF_MF_OUT_B         (:,:,:,:)
REAL, ALLOCATABLE   :: PFLXZTHVMF_OUT_B        (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZTHMF_OUT_B   (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZRMF_OUT_B        (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZUMF_OUT_B         (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZVMF_OUT_B         (:,:,:,:)
REAL, ALLOCATABLE   :: PTHL_UP_OUT_B         (:,:,:,:)
REAL, ALLOCATABLE   :: PRT_UP_OUT_B          (:,:,:,:)
REAL, ALLOCATABLE   :: PRV_UP_OUT_B          (:,:,:,:)
REAL, ALLOCATABLE   :: PRC_UP_OUT_B       (:,:,:,:)
REAL, ALLOCATABLE   :: PRI_UP_OUT_B       (:,:,:,:)
REAL, ALLOCATABLE   :: PU_UP_OUT_B         (:,:,:,:)
REAL, ALLOCATABLE   :: PV_UP_OUT_B        (:,:,:,:)
REAL, ALLOCATABLE   :: PTHV_UP_OUT_B   (:,:,:,:)
REAL, ALLOCATABLE   :: PW_UP_OUT_B   (:,:,:,:)
REAL, ALLOCATABLE   :: PFRAC_UP_OUT_B (:,:,:,:)
REAL, ALLOCATABLE   :: PEMF_OUT_B  (:,:,:,:)
REAL, ALLOCATABLE   :: ZDETR_OUT_B  (:,:,:,:)
REAL, ALLOCATABLE   :: ZENTR_OUT_B  (:,:,:,:)
INTEGER, ALLOCATABLE:: IKLCL_OUT_B  (:,:,:)
INTEGER, ALLOCATABLE:: IKETL_OUT_B  (:,:,:)
INTEGER, ALLOCATABLE:: IKCTL_OUT_B (:,:,:)

!Inputs to read
REAL, ALLOCATABLE   :: PDZZF               (:,:,:,:)
REAL, ALLOCATABLE   :: PZZ               (:,:,:,:)
REAL, ALLOCATABLE   :: PRHODJ            (:,:,:,:)
REAL, ALLOCATABLE   :: PRHODREF               (:,:,:,:)
REAL, ALLOCATABLE   :: PPABSM               (:,:,:,:)
REAL, ALLOCATABLE   :: PEXNM               (:,:,:,:)
REAL, ALLOCATABLE   :: PSFTH          (:,:,:)
REAL, ALLOCATABLE   :: PSFRV          (:,:,:)
REAL, ALLOCATABLE   :: PTHM             (:,:,:,:)
REAL, ALLOCATABLE   :: PRM              (:,:,:,:,:) !(KLON, 1, KLEV, KRR)
REAL, ALLOCATABLE   :: PUM                (:,:,:,:)
REAL, ALLOCATABLE   :: PVM                (:,:,:,:)
REAL, ALLOCATABLE   :: PTKEM              (:,:,:,:)
REAL, ALLOCATABLE   :: PSVM               (:,:,:,:,:) !(KLON,1,KLEV,KSV)
REAL, ALLOCATABLE   :: PTHL_UP              (:,:,:,:)
REAL, ALLOCATABLE   :: PRT_UP           (:,:,:,:)
REAL, ALLOCATABLE   :: PRV_UP           (:,:,:,:)
REAL, ALLOCATABLE   :: PRC_UP            (:,:,:,:)
REAL, ALLOCATABLE   :: PRI_UP               (:,:,:,:)
REAL, ALLOCATABLE   :: PU_UP               (:,:,:,:)
REAL, ALLOCATABLE   :: PV_UP               (:,:,:,:)
REAL, ALLOCATABLE   :: PTHV_UP               (:,:,:,:)
REAL, ALLOCATABLE   :: PW_UP               (:,:,:,:)
REAL, ALLOCATABLE   :: PFRAC_UP              (:,:,:,:)
REAL, ALLOCATABLE   :: PEMF         (:,:,:,:)
!Expected values to read
REAL, ALLOCATABLE   :: PDUDT_MF_OUT      (:,:,:,:)
REAL, ALLOCATABLE   :: PDVDT_MF_OUT     (:,:,:,:)
REAL, ALLOCATABLE   :: PDTHLDT_MF_OUT           (:,:,:,:)
REAL, ALLOCATABLE   :: PDRTDT_MF_OUT            (:,:,:,:)
REAL, ALLOCATABLE   :: PDSVDT_MF_OUT           (:,:,:,:,:) !(KLON,1,KLEV,KSV)
REAL, ALLOCATABLE   :: PSIGMF_OUT           (:,:,:,:)
REAL, ALLOCATABLE   :: PRC_MF_OUT           (:,:,:,:)
REAL, ALLOCATABLE   :: PRI_MF_OUT          (:,:,:,:)
REAL, ALLOCATABLE   :: PCF_MF_OUT           (:,:,:,:)
REAL, ALLOCATABLE   :: PFLXZTHVMF_OUT          (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZTHMF_OUT     (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZRMF_OUT          (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZUMF_OUT           (:,:,:,:)
REAL, ALLOCATABLE   :: ZFLXZVMF_OUT           (:,:,:,:)
REAL, ALLOCATABLE   :: PTHL_UP_OUT           (:,:,:,:)
REAL, ALLOCATABLE   :: PRT_UP_OUT            (:,:,:,:)
REAL, ALLOCATABLE   :: PRV_UP_OUT            (:,:,:,:)
REAL, ALLOCATABLE   :: PRC_UP_OUT         (:,:,:,:)
REAL, ALLOCATABLE   :: PRI_UP_OUT         (:,:,:,:)
REAL, ALLOCATABLE   :: PU_UP_OUT           (:,:,:,:)
REAL, ALLOCATABLE   :: PV_UP_OUT          (:,:,:,:)
REAL, ALLOCATABLE   :: PTHV_UP_OUT     (:,:,:,:)
REAL, ALLOCATABLE   :: PW_UP_OUT     (:,:,:,:)
REAL, ALLOCATABLE   :: PFRAC_UP_OUT   (:,:,:,:)
REAL, ALLOCATABLE   :: PEMF_OUT    (:,:,:,:)
REAL, ALLOCATABLE   :: ZDETR_OUT    (:,:,:,:)
REAL, ALLOCATABLE   :: ZENTR_OUT    (:,:,:,:)
INTEGER, ALLOCATABLE:: IKLCL_OUT  (:,:,:)
INTEGER, ALLOCATABLE:: IKETL_OUT  (:,:,:)
INTEGER, ALLOCATABLE:: IKCTL_OUT (:,:,:)

INTEGER :: NGPTOT, NPROMA, NGPBLKS, NFLEVG
INTEGER :: IOFF, IBL
LOGICAL :: LLEXIST
CHARACTER(LEN=32) :: CLFILE

CALL SETUP()

NGPTOT = NPROMA * NGPBLKS
KRR=6
KRRL=2
KRRI=3
KSV=0

IBL = 1
WRITE (CLFILE, '("data/",I8.8,".dat")') IBL
OPEN (IFILE, FILE=TRIM (CLFILE), FORM='UNFORMATTED') 
READ (IFILE) KLON, KLEV
CLOSE (IFILE)

IF (NFLEVG < 0) NFLEVG = KLEV

ALLOCATE (PDZZF_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PZZ_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRHODJ_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRHODREF_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PPABSM_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PEXNM_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PSFTH_B        (NPROMA,1,NGPBLKS))
ALLOCATE (PSFRV_B        (NPROMA,1,NGPBLKS))
ALLOCATE (PTHM_B           (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRM_B            (NPROMA,1,NFLEVG,KRR,NGPBLKS))
ALLOCATE (PUM_B              (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PVM_B              (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PTKEM_B            (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PSVM_B             (NPROMA,1,NFLEVG,KSV,NGPBLKS))
ALLOCATE (PTHL_UP_B            (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRT_UP_B         (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRV_UP_B         (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRC_UP_B          (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRI_UP_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PU_UP_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PV_UP_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PTHV_UP_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PW_UP_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PFRAC_UP_B            (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PEMF_B       (NPROMA,1,NFLEVG,NGPBLKS))

ALLOCATE (PDUDT_MF_B            (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PDVDT_MF_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PDTHLDT_MF_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PDRTDT_MF_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PDSVDT_MF_B             (NPROMA,1,NFLEVG,KSV,NGPBLKS))
ALLOCATE (PSIGMF_B              (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRC_MF_B              (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRI_MF_B           (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PCF_MF_B           (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PFLXZTHVMF_B             (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZFLXZTHMF_B            (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZFLXZRMF_B       (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZFLXZUMF_B       (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZFLXZVMF_B     (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZDETR_B      (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZENTR_B      (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (IKLCL_B      (NPROMA,1,NGPBLKS))
ALLOCATE (IKETL_B      (NPROMA,1,NGPBLKS))
ALLOCATE (IKCTL_B      (NPROMA,1,NGPBLKS))

ALLOCATE (PDUDT_MF_OUT_B    (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PDVDT_MF_OUT_B   (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PDTHLDT_MF_OUT_B         (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PDRTDT_MF_OUT_B          (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PDSVDT_MF_OUT_B         (NPROMA,1,NFLEVG,KSV,NGPBLKS))
ALLOCATE (PSIGMF_OUT_B         (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRC_MF_OUT_B         (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRI_MF_OUT_B        (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PCF_MF_OUT_B         (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PFLXZTHVMF_OUT_B        (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZFLXZTHMF_OUT_B   (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZFLXZRMF_OUT_B        (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZFLXZUMF_OUT_B         (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZFLXZVMF_OUT_B         (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PTHL_UP_OUT_B         (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRT_UP_OUT_B          (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRV_UP_OUT_B          (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRC_UP_OUT_B       (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PRI_UP_OUT_B       (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PU_UP_OUT_B         (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PV_UP_OUT_B        (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PTHV_UP_OUT_B   (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PW_UP_OUT_B   (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PFRAC_UP_OUT_B (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (PEMF_OUT_B  (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZDETR_OUT_B  (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (ZENTR_OUT_B  (NPROMA,1,NFLEVG,NGPBLKS))
ALLOCATE (IKLCL_OUT_B  (NPROMA,1,NGPBLKS))
ALLOCATE (IKETL_OUT_B  (NPROMA,1,NGPBLKS))
ALLOCATE (IKCTL_OUT_B  (NPROMA,1,NGPBLKS))


CALL SET (PDZZF_B             )
CALL SET (PZZ_B             )
CALL SET (PRHODJ_B         )
CALL SET (PRHODREF_B             )
CALL SET (PPABSM_B             )
CALL SET (PEXNM_B             )
CALL SET (PSFTH_B        )
CALL SET (PSFRV_B        )
CALL SET (PTHM_B           )
CALL SET (PRM_B            )
CALL SET (PUM_B              )
CALL SET (PVM_B              )
CALL SET (PTKEM_B            )
CALL SET (PSVM_B             )
CALL SET (PTHL_UP_B            )
CALL SET (PRT_UP_B         )
CALL SET (PRV_UP_B         )
CALL SET (PRC_UP_B          )
CALL SET (PRI_UP_B             )
CALL SET (PU_UP_B             )
CALL SET (PV_UP_B             )
CALL SET (PTHV_UP_B             )
CALL SET (PW_UP_B             )
CALL SET (PFRAC_UP_B            )
CALL SET (PEMF_B       )

CALL SET (PDUDT_MF_B            )
CALL SET (PDVDT_MF_B             )
CALL SET (PDTHLDT_MF_B             )
CALL SET (PDRTDT_MF_B             )
CALL SET (PDSVDT_MF_B             )
CALL SET (PSIGMF_B              )
CALL SET (PRC_MF_B              )
CALL SET (PRI_MF_B           )
CALL SET (PCF_MF_B           )
CALL SET (PFLXZTHVMF_B             )
CALL SET (ZFLXZTHMF_B            )
CALL SET (ZFLXZRMF_B       )
CALL SET (ZFLXZUMF_B       )
CALL SET (ZFLXZVMF_B     )
CALL SET (ZDETR_B      )
CALL SET (ZENTR_B      )
CALL SET (IKLCL_B      )
CALL SET (IKETL_B      )
CALL SET (IKCTL_B      )

CALL SET (PDUDT_MF_OUT_B    )
CALL SET (PDVDT_MF_OUT_B   )
CALL SET (PDTHLDT_MF_OUT_B         )
CALL SET (PDRTDT_MF_OUT_B          )
CALL SET (PDSVDT_MF_OUT_B         )
CALL SET (PSIGMF_OUT_B         )
CALL SET (PRC_MF_OUT_B         )
CALL SET (PRI_MF_OUT_B        )
CALL SET (PCF_MF_OUT_B         )
CALL SET (PFLXZTHVMF_OUT_B        )
CALL SET (ZFLXZTHMF_OUT_B   )
CALL SET (ZFLXZRMF_OUT_B        )
CALL SET (ZFLXZUMF_OUT_B         )
CALL SET (ZFLXZVMF_OUT_B         )
CALL SET (PTHL_UP_OUT_B         )
CALL SET (PRT_UP_OUT_B          )
CALL SET (PRV_UP_OUT_B          )
CALL SET (PRC_UP_OUT_B       )
CALL SET (PRI_UP_OUT_B       )
CALL SET (PU_UP_OUT_B         )
CALL SET (PV_UP_OUT_B        )
CALL SET (PTHV_UP_OUT_B   )
CALL SET (PW_UP_OUT_B   )
CALL SET (PFRAC_UP_OUT_B )
CALL SET (PEMF_OUT_B  )
CALL SET (ZDETR_OUT_B  )
CALL SET (ZENTR_OUT_B  )
CALL SET (IKLCL_OUT_B  )
CALL SET (IKETL_OUT_B  )
CALL SET (IKCTL_OUT_B  )

IOFF = 0
IBL = 0
LLEXIST = .TRUE.

DO WHILE(LLEXIST)
  IBL = IBL + 1
  WRITE (CLFILE, '("data/",I8.8,".dat")') IBL

  INQUIRE (FILE=TRIM (CLFILE), EXIST=LLEXIST)

  IF (LDVERBOSE) PRINT *, TRIM (CLFILE)

  IF (.NOT. LLEXIST) EXIT

  OPEN (IFILE, FILE=TRIM (CLFILE), FORM='UNFORMATTED') 
  
  READ (IFILE) KLON, KLEV

  IF (IBL == 1) THEN
    ALLOCATE (PDZZF               (NGPTOT,1,KLEV,1))
    ALLOCATE (PZZ               (NGPTOT,1,KLEV,1))
    ALLOCATE (PRHODJ               (NGPTOT,1,KLEV,1))
    ALLOCATE (PRHODREF               (NGPTOT,1,KLEV,1))
    ALLOCATE (PPABSM               (NGPTOT,1,KLEV,1))
    ALLOCATE (PEXNM               (NGPTOT,1,KLEV,1))
    ALLOCATE (PSFTH          (NGPTOT,1,1))
    ALLOCATE (PSFRV          (NGPTOT,1,1))
    ALLOCATE (PTHM             (NGPTOT,1,KLEV,1))
    ALLOCATE (PRM              (NGPTOT,1,KLEV,KRR,1))
    ALLOCATE (PUM                (NGPTOT,1,KLEV,1))
    ALLOCATE (PVM                (NGPTOT,1,KLEV,1))
    ALLOCATE (PTKEM              (NGPTOT,1,KLEV,1))
    ALLOCATE (PSVM               (NGPTOT,1,KLEV,KSV,1))
    ALLOCATE (PTHL_UP              (NGPTOT,1,KLEV,1))
    ALLOCATE (PRT_UP           (NGPTOT,1,KLEV,1))
    ALLOCATE (PRV_UP           (NGPTOT,1,KLEV,1))
    ALLOCATE (PRC_UP            (NGPTOT,1,KLEV,1))
    ALLOCATE (PRI_UP               (NGPTOT,1,KLEV,1))
    ALLOCATE (PU_UP               (NGPTOT,1,KLEV,1))
    ALLOCATE (PV_UP               (NGPTOT,1,KLEV,1))
    ALLOCATE (PTHV_UP               (NGPTOT,1,KLEV,1))
    ALLOCATE (PW_UP               (NGPTOT,1,KLEV,1))
    ALLOCATE (PFRAC_UP              (NGPTOT,1,KLEV,1))
    ALLOCATE (PEMF         (NGPTOT,1,KLEV,1))

    ALLOCATE (PDUDT_MF_OUT      (NGPTOT,1,KLEV,1))
    ALLOCATE (PDVDT_MF_OUT     (NGPTOT,1,KLEV,1))
    ALLOCATE (PDTHLDT_MF_OUT           (NGPTOT,1,KLEV,1))
    ALLOCATE (PDRTDT_MF_OUT            (NGPTOT,1,KLEV,1))
    ALLOCATE (PDSVDT_MF_OUT           (NGPTOT,1,KLEV,KSV,1))
    ALLOCATE (PSIGMF_OUT           (NGPTOT,1,KLEV,1))
    ALLOCATE (PRC_MF_OUT           (NGPTOT,1,KLEV,1))
    ALLOCATE (PRI_MF_OUT          (NGPTOT,1,KLEV,1))
    ALLOCATE (PCF_MF_OUT           (NGPTOT,1,KLEV,1))
    ALLOCATE (PFLXZTHVMF_OUT          (NGPTOT,1,KLEV,1))
    ALLOCATE (ZFLXZTHMF_OUT     (NGPTOT,1,KLEV,1))
    ALLOCATE (ZFLXZRMF_OUT          (NGPTOT,1,KLEV,1))
    ALLOCATE (ZFLXZUMF_OUT           (NGPTOT,1,KLEV,1))
    ALLOCATE (ZFLXZVMF_OUT           (NGPTOT,1,KLEV,1))
    ALLOCATE (PTHL_UP_OUT           (NGPTOT,1,KLEV,1))
    ALLOCATE (PRT_UP_OUT            (NGPTOT,1,KLEV,1))
    ALLOCATE (PRV_UP_OUT            (NGPTOT,1,KLEV,1))
    ALLOCATE (PRC_UP_OUT         (NGPTOT,1,KLEV,1))
    ALLOCATE (PRI_UP_OUT         (NGPTOT,1,KLEV,1))
    ALLOCATE (PU_UP_OUT           (NGPTOT,1,KLEV,1))
    ALLOCATE (PV_UP_OUT          (NGPTOT,1,KLEV,1))
    ALLOCATE (PTHV_UP_OUT     (NGPTOT,1,KLEV,1))
    ALLOCATE (PW_UP_OUT     (NGPTOT,1,KLEV,1))
    ALLOCATE (PFRAC_UP_OUT   (NGPTOT,1,KLEV,1))
    ALLOCATE (PEMF_OUT    (NGPTOT,1,KLEV,1))
    ALLOCATE (ZDETR_OUT    (NGPTOT,1,KLEV,1))
    ALLOCATE (ZENTR_OUT    (NGPTOT,1,KLEV,1))
    ALLOCATE (IKLCL_OUT    (NGPTOT,1,1))
    ALLOCATE (IKETL_OUT    (NGPTOT,1,1))
    ALLOCATE (IKCTL_OUT    (NGPTOT,1,1))
  ENDIF

  IF (IOFF+KLON > NGPTOT) THEN
    EXIT
  ENDIF

  READ(IFILE) PDZZF               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PZZ               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRHODJ               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRHODREF               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PPABSM               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PEXNM               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PSFTH          (IOFF+1:IOFF+KLON,:,1)
  READ(IFILE) PSFRV          (IOFF+1:IOFF+KLON,:,1)
  READ(IFILE) PTHM             (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRM              (IOFF+1:IOFF+KLON,:,:,:,1)
  READ(IFILE) PUM                (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PVM                (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PTKEM              (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PSVM               (IOFF+1:IOFF+KLON,:,:,:,1)
  READ(IFILE) PTHL_UP              (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRT_UP           (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRV_UP           (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRC_UP            (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRI_UP               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PU_UP               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PV_UP               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PTHV_UP               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PW_UP               (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PFRAC_UP              (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PEMF         (IOFF+1:IOFF+KLON,:,:,1)

  READ(IFILE)
  READ(IFILE) PDUDT_MF_OUT      (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PDVDT_MF_OUT     (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PDTHLDT_MF_OUT           (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PDRTDT_MF_OUT            (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PDSVDT_MF_OUT           (IOFF+1:IOFF+KLON,:,:,:,1)
  READ(IFILE) PSIGMF_OUT           (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRC_MF_OUT           (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRI_MF_OUT          (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PCF_MF_OUT           (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PFLXZTHVMF_OUT          (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) ZFLXZTHMF_OUT     (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) ZFLXZRMF_OUT          (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) ZFLXZUMF_OUT           (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) ZFLXZVMF_OUT           (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PTHL_UP_OUT           (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRT_UP_OUT            (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRV_UP_OUT            (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRC_UP_OUT         (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PRI_UP_OUT         (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PU_UP_OUT           (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PV_UP_OUT          (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PTHV_UP_OUT     (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PW_UP_OUT     (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PFRAC_UP_OUT   (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) PEMF_OUT    (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) ZDETR_OUT    (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) ZENTR_OUT    (IOFF+1:IOFF+KLON,:,:,1)
  READ(IFILE) IKLCL_OUT    (IOFF+1:IOFF+KLON,:,1)
  READ(IFILE) IKETL_OUT    (IOFF+1:IOFF+KLON,:,1)
  READ(IFILE) IKCTL_OUT    (IOFF+1:IOFF+KLON,:,1)
  
  CLOSE (IFILE)

  IOFF = IOFF + KLON

ENDDO

IF (NFLEVG /= KLEV) THEN
  CALL INTERPOLATE (NFLEVG, IOFF, PDZZF               )
  CALL INTERPOLATE (NFLEVG, IOFF, PZZ               )
  CALL INTERPOLATE (NFLEVG, IOFF, PRHODJ  )
  CALL INTERPOLATE (NFLEVG, IOFF, PRHODREF               )
  CALL INTERPOLATE (NFLEVG, IOFF, PPABSM               )
  CALL INTERPOLATE (NFLEVG, IOFF, PEXNM               )
!  CALL INTERPOLATE (NFLEVG, IOFF, PSFTH_B        )
!  CALL INTERPOLATE (NFLEVG, IOFF, PSFRV_B        )
  CALL INTERPOLATE (NFLEVG, IOFF, PTHM             )
  CALL INTERPOLATE (NFLEVG, IOFF, PRM              )
  CALL INTERPOLATE (NFLEVG, IOFF, PUM                )
  CALL INTERPOLATE (NFLEVG, IOFF, PVM                )
  CALL INTERPOLATE (NFLEVG, IOFF, PTKEM              )
  CALL INTERPOLATE (NFLEVG, IOFF, PSVM               )
  CALL INTERPOLATE (NFLEVG, IOFF, PTHL_UP              )
  CALL INTERPOLATE (NFLEVG, IOFF, PRT_UP           )
  CALL INTERPOLATE (NFLEVG, IOFF, PRV_UP           )
  CALL INTERPOLATE (NFLEVG, IOFF, PRC_UP            )
  CALL INTERPOLATE (NFLEVG, IOFF, PRI_UP               )
  CALL INTERPOLATE (NFLEVG, IOFF, PU_UP               )
  CALL INTERPOLATE (NFLEVG, IOFF, PV_UP               )
  CALL INTERPOLATE (NFLEVG, IOFF, PTHV_UP               )
  CALL INTERPOLATE (NFLEVG, IOFF, PW_UP               )
  CALL INTERPOLATE (NFLEVG, IOFF, PFRAC_UP              )
  CALL INTERPOLATE (NFLEVG, IOFF, PEMF         )

  CALL INTERPOLATE (NFLEVG, IOFF, PDUDT_MF_OUT      )
  CALL INTERPOLATE (NFLEVG, IOFF, PDVDT_MF_OUT     )
  CALL INTERPOLATE (NFLEVG, IOFF, PDTHLDT_MF_OUT           )
  CALL INTERPOLATE (NFLEVG, IOFF, PDRTDT_MF_OUT            )
  CALL INTERPOLATE (NFLEVG, IOFF, PDSVDT_MF_OUT           )
  CALL INTERPOLATE (NFLEVG, IOFF, PSIGMF_OUT           )
  CALL INTERPOLATE (NFLEVG, IOFF, PRC_MF_OUT           )
  CALL INTERPOLATE (NFLEVG, IOFF, PRI_MF_OUT          )
  CALL INTERPOLATE (NFLEVG, IOFF, PCF_MF_OUT           )
  CALL INTERPOLATE (NFLEVG, IOFF, PFLXZTHVMF_OUT          )
  CALL INTERPOLATE (NFLEVG, IOFF, ZFLXZTHMF_OUT     )
  CALL INTERPOLATE (NFLEVG, IOFF, ZFLXZRMF_OUT          )
  CALL INTERPOLATE (NFLEVG, IOFF, ZFLXZUMF_OUT           )
  CALL INTERPOLATE (NFLEVG, IOFF, ZFLXZVMF_OUT           )
  CALL INTERPOLATE (NFLEVG, IOFF, PTHL_UP_OUT           )
  CALL INTERPOLATE (NFLEVG, IOFF, PRT_UP_OUT            )
  CALL INTERPOLATE (NFLEVG, IOFF, PRV_UP_OUT            )
  CALL INTERPOLATE (NFLEVG, IOFF, PRC_UP_OUT         )
  CALL INTERPOLATE (NFLEVG, IOFF, PRI_UP_OUT         )
  CALL INTERPOLATE (NFLEVG, IOFF, PU_UP_OUT           )
  CALL INTERPOLATE (NFLEVG, IOFF, PV_UP_OUT          )
  CALL INTERPOLATE (NFLEVG, IOFF, PTHV_UP_OUT     )
  CALL INTERPOLATE (NFLEVG, IOFF, PW_UP_OUT     )
  CALL INTERPOLATE (NFLEVG, IOFF, PFRAC_UP_OUT   )
  CALL INTERPOLATE (NFLEVG, IOFF, PEMF_OUT    )
  CALL INTERPOLATE (NFLEVG, IOFF, ZDETR_OUT    )
  CALL INTERPOLATE (NFLEVG, IOFF, ZENTR_OUT    )
  !CALL INTERPOLATE (NFLEVG, IOFF, IKLCL_OUT    )
  !CALL INTERPOLATE (NFLEVG, IOFF, IKETL_OUT    )
  !CALL INTERPOLATE (NFLEVG, IOFF, IKCTL_OUT    )

ENDIF

CALL REPLICATE (IOFF, PDZZF               (:,:,:,1))
CALL REPLICATE (IOFF, PZZ               (:,:,:,1))
CALL REPLICATE (IOFF, PRHODJ               (:,:,:,1))
CALL REPLICATE (IOFF, PRHODREF               (:,:,:,1))
CALL REPLICATE (IOFF, PPABSM               (:,:,:,1))
CALL REPLICATE (IOFF, PEXNM               (:,:,:,1))
CALL REPLICATE (IOFF, PSFTH          (:,:,1))
CALL REPLICATE (IOFF, PSFRV          (:,:,1))
CALL REPLICATE (IOFF, PTHM             (:,:,:,1))
CALL REPLICATE (IOFF, PRM              (:,:,:,:,1))
CALL REPLICATE (IOFF, PUM                (:,:,:,1))
CALL REPLICATE (IOFF, PVM                (:,:,:,1))
CALL REPLICATE (IOFF, PTKEM              (:,:,:,1))
CALL REPLICATE (IOFF, PSVM               (:,:,:,:,1))
CALL REPLICATE (IOFF, PTHL_UP              (:,:,:,1))
CALL REPLICATE (IOFF, PRT_UP           (:,:,:,1))
CALL REPLICATE (IOFF, PRV_UP           (:,:,:,1))
CALL REPLICATE (IOFF, PRC_UP            (:,:,:,1))
CALL REPLICATE (IOFF, PRI_UP               (:,:,:,1))
CALL REPLICATE (IOFF, PU_UP               (:,:,:,1))
CALL REPLICATE (IOFF, PV_UP               (:,:,:,1))
CALL REPLICATE (IOFF, PTHV_UP               (:,:,:,1))
CALL REPLICATE (IOFF, PW_UP               (:,:,:,1))
CALL REPLICATE (IOFF, PFRAC_UP              (:,:,:,1))
CALL REPLICATE (IOFF, PEMF         (:,:,:,1))

CALL REPLICATE (IOFF, PDUDT_MF_OUT      (:,:,:,1))
CALL REPLICATE (IOFF, PDVDT_MF_OUT     (:,:,:,1))
CALL REPLICATE (IOFF, PDTHLDT_MF_OUT           (:,:,:,1))
CALL REPLICATE (IOFF, PDRTDT_MF_OUT            (:,:,:,1))
CALL REPLICATE (IOFF, PDSVDT_MF_OUT           (:,:,:,:,1))
CALL REPLICATE (IOFF, PSIGMF_OUT           (:,:,:,1))
CALL REPLICATE (IOFF, PRC_MF_OUT           (:,:,:,1))
CALL REPLICATE (IOFF, PRI_MF_OUT          (:,:,:,1))
CALL REPLICATE (IOFF, PCF_MF_OUT           (:,:,:,1))
CALL REPLICATE (IOFF, PFLXZTHVMF_OUT          (:,:,:,1))
CALL REPLICATE (IOFF, ZFLXZTHMF_OUT     (:,:,:,1))
CALL REPLICATE (IOFF, ZFLXZRMF_OUT          (:,:,:,1))
CALL REPLICATE (IOFF, ZFLXZUMF_OUT           (:,:,:,1))
CALL REPLICATE (IOFF, ZFLXZVMF_OUT           (:,:,:,1))
CALL REPLICATE (IOFF, PTHL_UP_OUT           (:,:,:,1))
CALL REPLICATE (IOFF, PRT_UP_OUT            (:,:,:,1))
CALL REPLICATE (IOFF, PRV_UP_OUT            (:,:,:,1))
CALL REPLICATE (IOFF, PRC_UP_OUT         (:,:,:,1))
CALL REPLICATE (IOFF, PRI_UP_OUT         (:,:,:,1))
CALL REPLICATE (IOFF, PU_UP_OUT           (:,:,:,1))
CALL REPLICATE (IOFF, PV_UP_OUT          (:,:,:,1))
CALL REPLICATE (IOFF, PTHV_UP_OUT     (:,:,:,1))
CALL REPLICATE (IOFF, PW_UP_OUT     (:,:,:,1))
CALL REPLICATE (IOFF, PFRAC_UP_OUT   (:,:,:,1))
CALL REPLICATE (IOFF, PEMF_OUT    (:,:,:,1))
CALL REPLICATE (IOFF, ZDETR_OUT    (:,:,:,1))
CALL REPLICATE (IOFF, ZENTR_OUT    (:,:,:,1))
CALL REPLICATE (IOFF, IKLCL_OUT    (:,:,1))
CALL REPLICATE (IOFF, IKETL_OUT    (:,:,1))
CALL REPLICATE (IOFF, IKCTL_OUT    (:,:,1))

CALL NPROMIZE (NPROMA, PDZZF               , PDZZF_B             )
CALL NPROMIZE (NPROMA, PZZ               , PZZ_B             )
CALL NPROMIZE (NPROMA, PRHODJ               , PRHODJ_B             )
CALL NPROMIZE (NPROMA, PRHODREF               , PRHODREF_B             )
CALL NPROMIZE (NPROMA, PPABSM               , PPABSM_B             )
CALL NPROMIZE (NPROMA, PEXNM               , PEXNM_B             )
CALL NPROMIZE (NPROMA, PSFTH          , PSFTH_B        )
CALL NPROMIZE (NPROMA, PSFRV          , PSFRV_B        )
CALL NPROMIZE (NPROMA, PTHM             , PTHM_B           )
CALL NPROMIZE (NPROMA, PRM              , PRM_B            )
CALL NPROMIZE (NPROMA, PUM                , PUM_B              )
CALL NPROMIZE (NPROMA, PVM                , PVM_B              )
CALL NPROMIZE (NPROMA, PTKEM              , PTKEM_B            )
CALL NPROMIZE (NPROMA, PSVM               , PSVM_B             )
CALL NPROMIZE (NPROMA, PTHL_UP              , PTHL_UP_B            )
CALL NPROMIZE (NPROMA, PRT_UP           , PRT_UP_B         ) 
CALL NPROMIZE (NPROMA, PRV_UP           , PRV_UP_B         ) 
CALL NPROMIZE (NPROMA, PRC_UP            , PRC_UP_B          ) 
CALL NPROMIZE (NPROMA, PRI_UP               , PRI_UP_B             ) 
CALL NPROMIZE (NPROMA, PU_UP               , PU_UP_B             )
CALL NPROMIZE (NPROMA, PV_UP               , PV_UP_B             )
CALL NPROMIZE (NPROMA, PTHV_UP               , PTHV_UP_B             )
CALL NPROMIZE (NPROMA, PW_UP               , PW_UP_B             )
CALL NPROMIZE (NPROMA, PFRAC_UP              , PFRAC_UP_B            )
CALL NPROMIZE (NPROMA, PEMF         , PEMF_B       )

CALL NPROMIZE (NPROMA, PDUDT_MF_OUT      , PDUDT_MF_OUT_B    )
CALL NPROMIZE (NPROMA, PDVDT_MF_OUT     , PDVDT_MF_OUT_B   )
CALL NPROMIZE (NPROMA, PDTHLDT_MF_OUT           , PDTHLDT_MF_OUT_B         )
CALL NPROMIZE (NPROMA, PDRTDT_MF_OUT            , PDRTDT_MF_OUT_B          )
CALL NPROMIZE (NPROMA, PDSVDT_MF_OUT           , PDSVDT_MF_OUT_B         )
CALL NPROMIZE (NPROMA, PSIGMF_OUT           , PSIGMF_OUT_B         )
CALL NPROMIZE (NPROMA, PRC_MF_OUT           , PRC_MF_OUT_B         )
CALL NPROMIZE (NPROMA, PRI_MF_OUT          , PRI_MF_OUT_B        )
CALL NPROMIZE (NPROMA, PCF_MF_OUT           , PCF_MF_OUT_B         )
CALL NPROMIZE (NPROMA, PFLXZTHVMF_OUT          , PFLXZTHVMF_OUT_B        )
CALL NPROMIZE (NPROMA, ZFLXZTHMF_OUT     , ZFLXZTHMF_OUT_B   )
CALL NPROMIZE (NPROMA, ZFLXZRMF_OUT          , ZFLXZRMF_OUT_B        )
CALL NPROMIZE (NPROMA, ZFLXZUMF_OUT           , ZFLXZUMF_OUT_B         )
CALL NPROMIZE (NPROMA, ZFLXZVMF_OUT           , ZFLXZVMF_OUT_B         )
CALL NPROMIZE (NPROMA, PTHL_UP_OUT           , PTHL_UP_OUT_B         )
CALL NPROMIZE (NPROMA, PRT_UP_OUT            , PRT_UP_OUT_B          )
CALL NPROMIZE (NPROMA, PRV_UP_OUT            , PRV_UP_OUT_B          )
CALL NPROMIZE (NPROMA, PRC_UP_OUT         , PRC_UP_OUT_B       )
CALL NPROMIZE (NPROMA, PRI_UP_OUT         , PRI_UP_OUT_B       )
CALL NPROMIZE (NPROMA, PU_UP_OUT           , PU_UP_OUT_B         )
CALL NPROMIZE (NPROMA, PV_UP_OUT          , PV_UP_OUT_B        )
CALL NPROMIZE (NPROMA, PTHV_UP_OUT     , PTHV_UP_OUT_B   )
CALL NPROMIZE (NPROMA, PW_UP_OUT     , PW_UP_OUT_B   )
CALL NPROMIZE (NPROMA, PFRAC_UP_OUT   , PFRAC_UP_OUT_B )
CALL NPROMIZE (NPROMA, PEMF_OUT    , PEMF_OUT_B  )
CALL NPROMIZE (NPROMA, ZDETR_OUT    , ZDETR_OUT_B  )
CALL NPROMIZE (NPROMA, ZENTR_OUT    , ZENTR_OUT_B  )
CALL NPROMIZE (NPROMA, IKLCL_OUT    , IKLCL_OUT_B  )
CALL NPROMIZE (NPROMA, IKETL_OUT    , IKETL_OUT_B  )
CALL NPROMIZE (NPROMA, IKCTL_OUT    , IKCTL_OUT_B  )

END SUBROUTINE 

END  MODULE
